﻿Type=StaticCode
Version=5.9
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
Sub Process_Globals
	Private fx As JFX
	Type TextMetric (Width As Double,Height As Double)
End Sub

Public Sub ExtractTextFromNode(obj As Object) As String
	If obj Is TextField Then
		Dim txf As TextField = obj
		Return txf.Text
		
	else If obj Is TextArea Then
		Dim txa As TextArea = obj
		Return txa.Text
		
	Else If obj Is Label Then
		Dim lb As Label = obj
		Return lb.Text
		
	Else If obj Is ComboBox Then
		Dim cmbx As ComboBox = obj
		If cmbx.SelectedIndex = -1 Then
			Return ""
		Else
			Return cmbx.Items.Get(cmbx.SelectedIndex)
		End If
		
	Else If obj Is ComposedNode Then
		Dim cmpsd As ComposedNode = obj
		Return cmpsd.GetList(";")
		
	End If
	Return obj
End Sub

'Ritorna le dimensioni del testo più grande nella lista
Public Sub GetLargerText(Text As List,Font As Font) As Double
	Dim size As Double = MeasureText(Text.Get(0),Font).Width
	For i = 1 To Text.Size-1
		Dim newSize As Double = MeasureText(Text.Get(i),Font).Width
		If newSize > size Then size = newSize
	Next
	Return size+5
End Sub

Public Sub MeasureText(Text As String,TFont As Font) As TextMetric
	Dim TB,Bounds As JavaObject
	Dim TM As TextMetric
	TB.InitializeStatic("javafx.scene.text.TextBuilder")
	Bounds = TB.RunMethodJO("create",Null).RunMethodJO("text",Array(Text)).RunMethodJO("font",Array(TFont)).RunMethodJO("build",Null).RunMethodJO("getLayoutBounds",Null)
	TM.Width = Bounds.RunMethod("getWidth",Null)
	TM.Height = Bounds.RunMethod("getHeight",Null)
	Return TM
End Sub

Public Sub SetNodeValue(n As Node, value As Object)
	If n Is ComboBox Then
		Dim cmbx As ComboBox = n
		Log(value&" : "&cmbx.Items.IndexOf(value))
		cmbx.SelectedIndex = cmbx.Items.IndexOf(value)
	Else If n Is TextField Then
		Dim txf As TextField = n
		txf.Text = value
	Else If n Is TextArea Then
		Dim txa As TextArea =n
		txa.Text = value
	End If
End Sub

Public Sub ClearNode(n As Node)
	If n Is TextField Then
		Dim txf As TextField = n
		txf.Text = ""
	Else If n Is TextArea Then
		Dim txa As TextArea = n
		txa.Text = ""
	Else If n Is ComboBox Then
		Dim cmbx As ComboBox = n
		cmbx.SelectedIndex = -1
	End If
End Sub

Public Sub GetMapKeys(m As Map) As List
	Dim l As List
	l.Initialize
	For i = 0 To m.Size-1
		l.Add(m.GetKeyAt(i))
	Next
	Return l
End Sub
