﻿Type=Class
Version=5.9
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
Sub Class_Globals
	Private ImpostazioniCorrenti As Impostazioni
	Private NomeTabellaDatabase As String
	Private ImpostazioneDb As Map 
	Private ImpostazioniLayout As Map 
	
	Private CampiDaVisualizzare As List
	
	Private fx As JFX
#Region Node
	Private SearchField As TextField
	Private SelectHead As ComboBox
	Private SplitPane As SplitPane
	Private VisualizzazioneRecord As ListView
	Private CampoDetails As TabPane
	Private ListDetails As ListView 'Tabella per details
	Private lblItem As Label
	Private lblItemValue As Label
#End Region

End Sub

Public Sub Initialize(TbPane As TabPane, Settings As Impostazioni)
	ImpostazioniCorrenti = 	Settings
	NomeTabellaDatabase = 	ImpostazioniCorrenti.TabellaDatabase
	ImpostazioneDb = 		ImpostazioniCorrenti.CampiDatabase
	ImpostazioniLayout = 	ImpostazioniCorrenti.CampiLayout
	
	CampiDaVisualizzare.Initialize
	
	TbPane.LoadLayout("RicercaVisualizza","Visualizza "&NomeTabellaDatabase)
	SplitPane.LoadLayout("Ricerca_ListView")
	SplitPane.LoadLayout("Ricerca_Details")
	SplitPane.DividerPositions = Array As Double(0.15,0.85)
	CampoDetails.LoadLayout("RicercaVisualizza_ListDetails","Dati")
	CampoDetails.LoadLayout("RicercaVisualizza_Note","Note")
	
	For i = 0 To ImpostazioniLayout.Size-1
		Dim icl As ImpostazioniCampoLayout = ImpostazioniLayout.GetValueAt(i)
		If icl.SearchVisible Then CampiDaVisualizzare.Add(ImpostazioniLayout.GetKeyAt(i))
	Next

	InitializeSelectHeadToSearch
	LoadAllRecords
End Sub

'Inizializza SelectHead per ricercare solo i campi specificati in CampiDaVisualizzare
Private Sub InitializeSelectHeadToSearch
	SelectHead.Items.AddAll(CampiDaVisualizzare)
End Sub

Public Sub LoadAllRecords
	VisualizzazioneRecord.Items.Clear
	Dim records As List = SQLUtils.AllResult(NomeTabellaDatabase,ImpostazioneDb)
	InsertInMaster(records)
End Sub

'Inserisce i record trovati, nella visualizzazione Master.
'Viene creato un Pane con al suo interno tante Label quanti sono i campi da Visualizzare.
'Ogni Pane (Rappresenta il singolo record), nel tag sono contenute tutte le informazioni riguardo al record
Private Sub InsertInMaster(RecordSet As List)
	For i = 0 To RecordSet.Size-1
		Dim rec As Map = RecordSet.Get(i)
		Dim p As AnchorPane
		p.Initialize("")
		p.Tag = rec
		For j = 0 To CampiDaVisualizzare.Size-1
			Dim lb As Label
			Dim value As String = rec.Get(CampiDaVisualizzare.Get(j))
			lb.Initialize("")
			lb.Text = value
			p.AddNode(lb,0,20dip*j,-1,-1)
		Next
		VisualizzazioneRecord.Items.Add(p)
	Next
End Sub

Private Sub SearchField_TextChanged(Old As String, New As String) '<-------------------------------------------------------------------------------- Da Rivedere
	If SelectHead.SelectedIndex = -1 Then Return
	Dim selectedColumn As String = SelectHead.Items.Get(SelectHead.SelectedIndex)
	VisualizzazioneRecord.Items.Clear
	Dim records As List = SQLUtils.ExecuteMap("SELECT * FROM "&NomeTabellaDatabase&" WHERE `"&selectedColumn&"` LIKE '%"&New&"%'",ImpostazioneDb)
	InsertInMaster(records)
End Sub

Private Sub VisualizzazioneRecord_SelectedIndexChanged(index As Int)
	If index = -1 Then Return
	ListDetails.Items.Clear
	Dim p As Pane = VisualizzazioneRecord.Items.Get(index)
	Dim record As Map = p.Tag
	
	For i = 0 To ImpostazioniLayout.Size-1
		Dim nameField As String = ImpostazioniLayout.GetKeyAt(i)				'Nome del campo da inserire
		Dim icl As ImpostazioniCampoLayout = ImpostazioniLayout.GetValueAt(i)	'Impostazioni del campo
		Dim value As Object = record.Get(icl.DbColumnCorrespond)				'Dalle impostazioni estraggo il nome della colonna corrispondente e dal record ne estraggo il valore
		
		Select nameField
			
			Case "Note"
				Continue
				
			Case "Grana"
				Dim lv As ListView
				lv.Initialize("")
				lv.Items.AddAll(Regex.Split(";",value))
				value = lv
				
			Case "Legante"
				value = SQLUtils.SingleStringResult("SELECT Nome FROM Leganti WHERE ID = "&value)
				
			Case "Elementi"
				Dim l As List = SQLUtils.ExecuteMap("Select `Elementi`.`Nome` FROM `Elementi` INNER JOIN (`Leganti` INNER JOIN `ComposizioneLeganti` ON `Leganti`.`ID` = `ComposizioneLeganti`.`ID_Legante`) ON `Elementi`.`ID` = `ComposizioneLeganti`.`ID_Elemento` WHERE `Leganti`.`ID` = "&record.Get("ID"),ImpostazioneDb)
				Dim lv As ListView
				lv.Initialize("")
				For j = 0 To l.Size-1
					Dim m As Map = l.Get(j)
					lv.Items.Add(m.Get("Nome"))
				Next
				'value = lv
				
		End Select
	
		ListDetails.Items.Add(ItemToList(nameField,value))
		
	Next
End Sub

Private Sub ItemToList(NameField As String, Value As Object) As Pane
	Dim pane As Pane = CreatePaneForListItem
	pane.LoadLayout("LstItems")
	lblItem.Text = NameField
	lblItemValue.Text = Value
	Return pane
End Sub

Private Sub CreatePaneForListItem As Pane
	Dim pane As Pane
	pane.Initialize("")
	pane.SetSize(ListDetails.Width-40,32)
	Return pane
End Sub

