﻿Type=StaticCode
Version=5.9
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Utilità per operazioni su stesso db con più tabelle
Private Sub Process_Globals
	Public const DB_INTEGER As String = "INTEGER"
	Public const DB_BLOB As String = 	"BLOB"
	Public const DB_TEXT As String = 	"TEXT"
	Public const DB_DOUBLE  As String = "DOUBLE"
	
	Private fx As JFX
	Private SQL As SQL
	Private Driver As String
	Private Jbdc As String
	Private usrn As String
	Private pwr As String
	
	Private checkReload As Int = 10 'ogni dieci caratteri viene ricaricata la tabella
	Private resultRec As List
End Sub

Public Sub Initialize(DriverClass As String, JbdcURL As String, Username As String, Password As String)
	Driver = DriverClass
	Jbdc = JbdcURL
	usrn = Username
	pwr = Password
	resultRec.Initialize
End Sub

Private Sub Connect
	SQL.Initialize2(Driver,Jbdc,usrn,pwr)
End Sub
Private Sub Disconnect
	SQL.Close
End Sub

Public Sub TestConnection As Boolean
	Try
		Connect
		Disconnect
		Return True
	Catch
		Disconnect
		Return False
	End Try
End Sub

Sub GetColumnsName(NameTable As String) As List
	Dim l As List
	l.Initialize
	Connect
	Dim records As ResultSet = SQL.ExecQuery("SELECT COLUMN_NAME FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME='"&NameTable&"'")
	Do While records.NextRow
		l.Add(records.GetString2(0))
	Loop
	Disconnect
	Return l
End Sub

'Ritorna una lista contente i records sotto forma di map, dove la key è il nome della colonna e il value e il valore
Public Sub AllResult(NameTable As String, ColumnType As Map) As List
	Dim l As List
	Dim result As ResultSet
	Dim Query As String = "SELECT * FROM "&NameTable
	l.Initialize
	Connect
	result = SQL.ExecQuery(Query)
	Do While result.NextRow
		Dim m1 As Map
		m1.Initialize
		For i = 0 To result.ColumnCount-1
			Dim nameCol As String = result.GetColumnName(i)
			Dim t As String = ColumnType.Get(nameCol)
			Select t
				Case DB_TEXT
					m1.put(nameCol,result.GetString2(i))
				Case DB_INTEGER
					m1.put(nameCol,result.GetInt2(i))
				Case DB_DOUBLE
					m1.put(nameCol,result.GetDouble2(i))
				Case DB_BLOB
					m1.put(nameCol,result.GetBlob2(i))
			End Select
		Next
		l.Add(m1)
	Loop
	result.Close
	Disconnect
	Return l
End Sub

Public Sub ExecuteMap(Query As String, ColumnType As Map) As List
	Dim l As List
	Dim result As ResultSet
	l.Initialize
	Connect
	result = SQL.ExecQuery(Query)
	Do While result.NextRow
		Dim m1 As Map
		m1.Initialize
		For i = 0 To result.ColumnCount-1
			Dim nameCol As String = result.GetColumnName(i)
			Dim t As String = ColumnType.Get(nameCol)
			Select t
				Case DB_TEXT
					m1.put(nameCol,result.GetString2(i))
				Case DB_INTEGER
					m1.put(nameCol,result.GetInt2(i))
				Case DB_DOUBLE
					m1.put(nameCol,result.GetDouble2(i))
				Case DB_BLOB
					m1.put(nameCol,result.GetBlob2(i))
			End Select
		Next
		l.Add(m1)
	Loop
	result.Close
	Disconnect
	Return l
End Sub

Public Sub GetSingleRow(Nametable As String,KeyName As String, KeyValue As String) As Map
	Dim m As Map
	Dim result As ResultSet
	m.Initialize
	Connect
	result = SQL.ExecQuery("SELECT * FROM "&Nametable&" WHERE "&KeyName&" = "&KeyValue)
	Do While result.NextRow
		For i = 0 To result.ColumnCount-1
			m.Put(result.GetColumnName(i),result.GetString2(i))
		Next
	Loop
	result.Close
	Disconnect
	Return m
End Sub

Public Sub SingleStringResult(Query As String) As String
	Dim st As String
	Dim rSet As ResultSet
	Connect
	rSet = SQL.ExecQuery(Query)
	Do While rSet.NextRow
		st = rSet.GetString2(0)
	Loop
	rSet.Close
	Disconnect
	Return st
End Sub





'Restituisce una mappa contente come key la primary key e come valori la lista dei campi indicati
Sub GetAllResult2(NameTable As String,PrimaryKey As String,Columns As List) As Map
	Dim Query As StringBuilder
	Query.Initialize
	Dim m As Map
	m.Initialize
	
	Query.Append("SELECT `"&PrimaryKey&"`,")
	For i = 0 To Columns.Size-1
		Query.Append("`").Append(Columns.Get(i)).Append("`,")
	Next
	Query.Remove(Query.Length-1,Query.Length)
	Query.Append(" FROM ").Append(NameTable)
	
	Connect
	
	Dim record As ResultSet = SQL.ExecQuery(Query)
	Do While record.NextRow
		Dim l As List
		l.Initialize
		Dim id As Object = record.GetString2(0)
		For j = 1 To record.ColumnCount-1 'Salta il campo id
			l.Add(record.GetString2(j))
		Next
		m.Put(id,l)
	Loop
	
	record.Close
	Disconnect
	
	Return m
End Sub

Sub GetAllResult(NameTable As String) As List
	Dim l As List
	l.Initialize
	Connect
	Dim record As ResultSet = SQL.ExecQuery("SELECT * FROM "&NameTable)
	Do While record.NextRow
		Dim r(record.ColumnCount) As String
		For i = 0 To r.Length-1
			r(i) = record.GetString2(i)
		Next
		l.Add(r)
	Loop
	record.Close
	Disconnect
	resultRec = l
	Return l
End Sub



Sub QueryWithLike(NameTable As String, ColumnsName As String, likeCondition As String) As List
	If checkReload <= 0 Or resultRec.Size = 0 Then
		resultRec = GetAllResult(NameTable)
		checkReload = 10
		Log("Reload")
	End If
	checkReload = checkReload - 1
	Dim l As List
	l.Initialize
	Dim position As Int = GetColumnsName(NameTable).IndexOf(ColumnsName) 'restituisce la posizione dentro all'array
	If position = -1 Then Return l
	For i = 0 To resultRec.Size-1
		Dim r() As String = resultRec.Get(i)
		If r(position) = Null Then r(position) = ""
		If r(position).Contains(likeCondition) Then
			l.Add(r)
		End If
	Next
	Return l
End Sub

'Sub QueryWithLike2(NameTable As String) 
'	Connect
'	SQL.ExecQuery("SELECT * "
'End Sub

'Ritorna una lista dei valori in una colonna
'Se OnlyOneForValue è vero, allora verrà ritornata una lista senza valori uguali 
Sub SingleColumnResults(NameTable As String, ColumnsName As String, OnlyOneForValue As Boolean) As List
	Dim l As List
	l.Initialize
	Connect
	Dim record As ResultSet = SQL.ExecQuery("SELECT * FROM "&NameTable)
	Do While record.NextRow
		Dim value As Object = record.GetString(ColumnsName)
		If OnlyOneForValue Then
			If l.IndexOf(value) = -1 Then l.Add(value)
		Else
			l.Add(value)
		End If
	Loop
	record.Close
	Disconnect
	Return l
End Sub

'Multiple Result
Sub GetColumnsResult(NameTable As String, whereCondition As String) As List
	Dim l As List
	l.Initialize
	Connect
	Dim record As ResultSet = SQL.ExecQuery("SELECT * FROM "&NameTable&" WHERE "&whereCondition)
	Do While record.NextRow
		Dim recArray(record.ColumnCount) As String 
		For i = 0 To record.ColumnCount-1
			recArray(i) = record.GetString2(i)
		Next
		l.Add(recArray)
	Loop
	record.Close
	Disconnect
	Return l
End Sub

'Single Result
Sub GetColumnResult2(NameTable As String, ColumnsName As String ,whereCondition As String ,OnlyOneForValue As Boolean) As List
	Dim l As List
	l.Initialize
	Connect
	Dim record As ResultSet = SQL.ExecQuery("SELECT '"&ColumnsName&"' FROM "&NameTable&" WHERE "&whereCondition)
	Do While record.NextRow
		Dim value As Object = record.GetString2(0)
		If OnlyOneForValue Then
			
			Dim Check1 As Boolean = l.IndexOf(value) = -1
			Dim j As JStringFunctions
			j.Initialize
			Dim Check2 As Boolean =  Not(j.IsEmpty(value))
			Dim Check3 As Boolean = value <> Null
			
			If Check1 And Check2 And Check3 Then 
				l.Add(value)
			End If
		Else
			l.Add(value)
		End If
	Loop
	record.Close
	Disconnect
	Return l
End Sub


Sub GetSingleResult(NameTable As String, ColumnName As String, WhereCondition As String) As String
	Dim result As String
	Connect
	Dim query As String = $"SELECT ${ColumnName} FROM ${NameTable} WHERE ${WhereCondition}"$
	result = SQL.ExecQuerySingleResult(query)
	Disconnect
	Return result
End Sub

'NameTable = nome tabella
'newData = nuovo record da da registrare nel db
'PrimaryKeyValue = valore che identifica in maniera univoca il records. es: "ID = 1"
Sub UpdateRecord(NameTable As String, newData() As Object, PrimaryKeyValue As String)
	Dim stB As StringBuilder
	stB.Initialize
	stB.Append("UPDATE "&NameTable&" SET ")
	Dim nCol As List = GetColumnsName(NameTable)
	For i = 0 To nCol.Size-1
		stB.Append("`").Append(nCol.get(i)).Append("` = ").Append("'"&newData(i)&"' ,")
	Next
	Dim st As String = stB.ToString
	st = st.SubString2(0,st.Length-1)
	st = st&"WHERE "&PrimaryKeyValue
	Connect
	SQL.BeginTransaction
	Try
		SQL.ExecNonQuery(st)
		SQL.TransactionSuccessful
	Catch
		SQL.Rollback
		fx.Msgbox(Null,"Aggiornamento non riuscito"&CRLF&LastException.Message,"Update Danied")
	End Try
	Disconnect
	checkReload = 0
End Sub

'Il campo NUll è inserito in automatico
Sub InsertRecord(NameTable As String, ColumnsName As List, Values As List)
	Dim stB As StringBuilder
	stB.Initialize
	stB.Append("INSERT INTO ").Append(NameTable).Append(" (")
	For i = 0 To ColumnsName.Size-1
		stB.Append("`").Append(ColumnsName.Get(i)).Append("` ,")
	Next
	stB.Remove(stB.Length-1,stB.Length)
	stB.Append(") VALUES (").Append(Null).Append(",")
	For j = 0 To Values.Size-1
		stB.Append("'").Append(Values.Get(J)).Append("',")
	Next
	stB.Remove(stB.Length-1,stB.Length)
	stB.Append(")")
	Connect
	SQL.BeginTransaction
	Try
		SQL.ExecNonQuery(stB.ToString)
		SQL.TransactionSuccessful
	Catch
		SQL.Rollback
		fx.Msgbox(Null,"Inserimento non riuscito"&CRLF&LastException.Message,"Insert Danied")
	End Try
	Disconnect
End Sub


